
var fs = require('fs');
var path = require('path');
var mkdirp = require('mkdirp');

module.exports = function(obj) {
  return new Promise(function(resolve,reject) {
    var builddir = obj.config.builddir;
    var todo = 0;

    var doWrite = function(file, content) {
      todo++;
      mkdirp(path.dirname(file), function() {
        fs.writeFile(file, content, function(err) {
          if(err) reject(err);
          todo--;
          if(todo <= 0) resolve(obj);
        });
      });
    }

    var writeFile = function(article) {
      var filename = path.join(builddir,article.file,'index.html');
      doWrite(filename, article.content);
      if(article.otherContent) {
        article.otherContent.forEach(function(o) {
          var f = path.join(builddir,article.file,'index.'+o.type);
          console.log(f);
          doWrite(f, o.content);
        })
      }
    }
    obj.pages.forEach(function(o) { writeFile(o); })
    obj.redirects.forEach(function(o) { writeFile(o); })
    obj.tags.forEach(function(o) { writeFile(o); })
    if(todo <= 0) resolve(obj);
  })
}
